#include "colormaps.h"
#include <memory>

extern const float colormap_rainbow_data[];
extern const float colormap_redgreen_data[];
extern const float colormap_orangeblue_data[];
extern const float colormap_magentacyan_data[];
extern const float colormap_purpleyellow_data[];
extern const float colormap_blackwhite_data[];

extern const float colormap_viridis_magma_data[];
extern const float colormap_viridis_inferno_data[];
extern const float colormap_viridis_plasma_data[];
extern const float colormap_viridis_viridis_data[];
extern const float colormap_viridis_cividis_data[];
extern const float colormap_viridis_rocket_data[];
extern const float colormap_viridis_mako_data[];
extern const float colormap_viridis_turbo_data[];

const std::map<std::string, ColorMapData> colormaps = {
    {"redgreen", ColorMapData::fromArray(colormap_redgreen_data, 2, ColorSpace::CIELAB)},
    {"orangeblue", ColorMapData::fromArray(colormap_orangeblue_data, 2, ColorSpace::CIELAB)},
    {"magentacyan", ColorMapData::fromArray(colormap_magentacyan_data, 2, ColorSpace::CIELAB)},
    {"purpleyellow", ColorMapData::fromArray(colormap_purpleyellow_data, 2, ColorSpace::CIELAB)},
    {"blackwhite", ColorMapData::fromArray(colormap_blackwhite_data, 2, ColorSpace::CIELAB)},

    {"rainbow", ColorMapData::fromArray(colormap_rainbow_data, 7, ColorSpace::CIELAB)},

    {"magma", ColorMapData::fromArray(colormap_viridis_magma_data, 255, std::nullopt)},
    {"inferno", ColorMapData::fromArray(colormap_viridis_inferno_data, 255, std::nullopt)},
    {"plasma", ColorMapData::fromArray(colormap_viridis_plasma_data, 255, std::nullopt)},
    {"viridis", ColorMapData::fromArray(colormap_viridis_viridis_data, 255, std::nullopt)},
    {"cividis", ColorMapData::fromArray(colormap_viridis_cividis_data, 255, std::nullopt)},
    {"rocket", ColorMapData::fromArray(colormap_viridis_rocket_data, 255, std::nullopt)},
    {"mako", ColorMapData::fromArray(colormap_viridis_mako_data, 255, std::nullopt)},
    {"turbo", ColorMapData::fromArray(colormap_viridis_turbo_data, 255, std::nullopt)},
};